uk.ac.starlink.table

## Class CountCheckRowSequence

- java.lang.Object
- - uk.ac.starlink.table.CountCheckRowSequence

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, RowData, RowSequence, Sequence

      public class CountCheckRowSequence
      extends java.lang.Object
      implements RowSequence

  RowSequence wrapper class that guarantees a given number of rows. The expectation is that the underlying row sequence has the declared row count, but if it has a different number the output of this sequence is forced to the declared value by adding dummy rows or discarding extra rows as required. If such adjustments are required, suitable messages are written through the logging system.
  Since:
    10 Nov 2022

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Indicates that this sequence will not be required any more.
    `java.lang.Object` | `getCell(int icol)` Returns the contents of a cell in the current row.
    `java.lang.Object[]` | `getRow()` Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table.
    `static RowSequence` | `getSafeRowSequence(RowSequence rseq, int ncol, long nrow)` Returns a row sequence guaranteed to give the required number of rows.
    `boolean` | `next()` Attempts to advance the current row to the next one.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### next

          public boolean next()
                       throws java.io.IOException

      Description copied from interface: `RowSequence`
      Attempts to advance the current row to the next one. If `true` is returned the attempt has been successful, and if `false` is returned there are no more rows in this sequence. Since the initial position of a RowSequence is before the first row, this method must be called before current row data can be accessed using the `RowSequence.getCell(int)` or `RowSequence.getRow()` methods.
      Specified by:
        `next` in interface `RowSequence`
      Specified by:
        `next` in interface `Sequence`
      Returns:
        `true` iff this sequence has been advanced to the next row
      Throws:
        `java.io.IOException` - if there is some error

    - #### getCell

          public java.lang.Object getCell(int icol)
                                   throws java.io.IOException

      Description copied from interface: `RowSequence`
      Returns the contents of a cell in the current row. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).
      Specified by:
        `getCell` in interface `RowData`
      Specified by:
        `getCell` in interface `RowSequence`
      Parameters:
        `icol` - column index
      Returns:
        the contents of cell `icol` in the current row
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### getRow

          public java.lang.Object[] getRow()
                                    throws java.io.IOException

      Description copied from interface: `RowSequence`
      Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).
      Specified by:
        `getRow` in interface `RowData`
      Specified by:
        `getRow` in interface `RowSequence`
      Returns:
        an array of the objects in each cell in row `irow`
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### close

          public void close()
                     throws java.io.IOException

      Description copied from interface: `RowSequence`
      Indicates that this sequence will not be required any more. This should release resources associated with this object. The effect of calling any of the other methods following a `close` is undefined.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `RowSequence`
      Throws:
        `java.io.IOException`

    - #### getSafeRowSequence

          public static RowSequence getSafeRowSequence(RowSequence rseq,
                                                       int ncol,
                                                       long nrow)

      Returns a row sequence guaranteed to give the required number of rows.
      Parameters:
        `rseq` - row sequence on which the returned one is based
        `ncol` - number of columns (required for constructing dummy rows)
        `nrow` - required number of rows, or -1 for no requirement
      Returns:
        safe row sequence; if `nrow<0` the input sequence will be returned